05Robot 3.0

- Main Page
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Signals | Public Member Functions | Public Attributes | List of all members
Processor Class Reference
Computer Vision Module

Image processor base class. More...

`#include <Processor.h>`

Inheritance diagram for Processor:

## Public Types

## Signals
void | writeInfo (QString info)
| Data logger. More...

## Public Member Functions
| Processor ()
| Starts internal clock. More...
virtual int | start ()
| Starts image processing, should be overridden in descendant class. More...
virtual int | process (int t1, int t2)
| Processes frames in input buffer, should be overridden in descendant class. More...
virtual int | processSpecial (string s)
| Processes special command, should be overridden in descendant class. More...
virtual int | stop ()
| Stops image processing, should be overridden in descendant class. More...
Public Member Functions inherited from cXmlIO
| cXmlIO (int _xmlID=0, QObject *parent=nullptr)
virtual QString | sXmlKey ()
| Generates key of XML entry (as name of the serialised class is) More...
virtual void | findInXML (QString &fileName, bool compareXmlID=true)
| serches th file for XML key corr to class name and fill class properties according to entries found More...
virtual void | writeXml (QXmlStreamWriter &xml)
| Writes XML entries to file. Can be overloaded to save additional data, apart from object properties. More...
virtual void | readXml (QXmlStreamReader &xml)
| Called by findInXML. Reads XML entries. Has to be overloaded if additional data was written to file in object entry. More...
virtual void | writeCsvData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | writeCsvVector (QXmlStreamWriter &stream, QString key, const QVector< double > &s)
virtual void | readCsvData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
virtual void | readCsvVector (QXmlStreamReader &stream, QVector< double > &s)
virtual void | write64BaseData (QXmlStreamWriter &stream, QString key, const QVector< QVector< double > > &s)
virtual void | read64BaseData (QXmlStreamReader &stream, QVector< QVector< double > > &s)
template<typename T >
void | writeData (QXmlStreamWriter &stream, QString key, const T &data)
template<typename T >
void | readData (QXmlStreamReader &stream, T &data)
int | getXmlID () const
void | setXmlID (int value)

## Public Attributes
InputType | inputType
| Processor input data type. More...
vector< cv::Mat * > | inputMat
| Vector of input images. More...
vector< vector< cv::Point2f > * > | inputPoint2
| Vector of input series of 2D points. More...
vector< vector< cv::Point3d > * > | inputPoint3
| Vector of input series of 3D points. More...
vector< QString * > | cameraName
| Vector of pointers to connected cameras names. More...
vector< cv::Mat * > | outputMat
| Vector of output images. More...
vector< vector< cv::Point2f > * > | outputPoint2
| Vector of output series of 2D points. More...
vector< vector< cv::Point3d > * > | outputPoint3
| Vector of input series of 3D points. More...
QTime | m_time
| Internal clock. More...

## Additional Inherited Members
Static Public Member Functions inherited from cXmlIO
static void | metaCopy (QObject *dest, QObject *src)
Protected Member Functions inherited from cXmlIO
void | metaDataXmlReader (QXmlStreamReader &stream, QObject &obj, bool isUser=true)
void | metaDataXmlWriter (QXmlStreamWriter &stream, const QObject &obj, bool isUser=true)
Properties inherited from cXmlIO
int | xmlID
| Defines uniqe identifier for object in XML file. More...

## Detailed Description

Image processor base class.

## Member Enumeration Documentation

enum InputType

Processor input data type enum.

Enumerator
InputTypeMat | image
InputTypePoint2 | vector of 2D points
InputTypePoint3 | vector of 3D points

## Constructor & Destructor Documentation

Processor | ( |  | ) |
| inline

Starts internal clock.

## Member Function Documentation

virtual int process | ( | int | t1,
|  | int | t2
| ) |  |
| virtual

Processes frames in input buffer, should be overridden in descendant class.

Parameters

  t1 | Cameras trigger time
  t2 | Cameras acquisition finish time

Returns
  0 on success

Reimplemented in Processor_ObjectExtraction, Processor_PlaneCalibration, and Processor_CameraCalibration.

virtual int processSpecial | ( | string | s | ) |
| virtual

Processes special command, should be overridden in descendant class.

Parameters

  s | Command string

Returns
  0 on success

Reimplemented in Processor_ObjectExtraction, Processor_PlaneCalibration, and Processor_CameraCalibration.

virtual int start | ( |  | ) |
| virtual

Starts image processing, should be overridden in descendant class.

Returns
  0 on success

Reimplemented in Processor_ObjectExtraction, Processor_PlaneCalibration, and Processor_CameraCalibration.

virtual int stop | ( |  | ) |
| virtual

Stops image processing, should be overridden in descendant class.

Returns
  0 on success

Reimplemented in Processor_ObjectExtraction, Processor_PlaneCalibration, and Processor_CameraCalibration.

void writeInfo | ( | QString | info | ) |
| signal

Data logger.

Parameters

  info | text to log

## Member Data Documentation

vector<QString *> cameraName

Vector of pointers to connected cameras names.

vector<cv::Mat *> inputMat

Vector of input images.

vector<vector<cv::Point2f> *> inputPoint2

Vector of input series of 2D points.

vector<vector<cv::Point3d> *> inputPoint3

Vector of input series of 3D points.

InputType inputType

Processor input data type.

QTime m_time

Internal clock.

vector<cv::Mat *> outputMat

Vector of output images.

vector<vector<cv::Point2f> *> outputPoint2

Vector of output series of 2D points.

vector<vector<cv::Point3d> *> outputPoint3

Vector of input series of 3D points.

The documentation for this class was generated from the following file:

- processors/Processor.h